<?php



    
/*
* $Id: zipur_language_tool.php
* $Loc: /admin/
*
* Name: zipurLanguageTool
* Version: 1.1.0
* Release Date: 03/03/2023
* Author: Preston Lord
* 	 phoenixaddons.com / @zipurman / plord@inetx.ca
*
* License: Released under the GNU General Public License
*
* Comments: Copyright (c) 2020: Preston Lord - @zipurman - Intricate Networks Inc.
* 
* 
*   Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
* 
*   1. Re-distributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
* 
*   2. Re-distributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
* 
*   3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
* 
*   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS \"AS IS\" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* (Packaged with Zipur Bundler v2.2.0)
*/










    require 'includes/application_top.php';
    require 'includes/template_top.php';


        function zlt_db_query( $query, $link = 'db' ) {

            if ( version_compare( '1.0.8.19', zlt_phoenix_version() ) > 0 ) {
                return tep_db_query( $query );
            } else {
                return $GLOBALS[ $link ]->query( $query );
            }

        }

        function zlt_fetch_array( $db_query ) {

            if ( version_compare( '1.0.8.19', zlt_phoenix_version() ) > 0 ) {
                return tep_db_fetch_array( $db_query );
            } else {
                return $db_query->fetch_assoc();
            }

        }

        function zlt_redirect( $url, $attr = '' ) {

            if ( version_compare( '1.0.8.19', zlt_phoenix_version() ) > 0 ) {
                tep_redirect( tep_href_link( $url, $attr ) );
            } else {
                if ( ! empty( $attr ) ) {
                    $url . $url = '?' . $attr;
                }
                Href::redirect( $url );
            }

        }

        function zlt_phoenix_version() {

            return trim( file_get_contents( DIR_FS_CATALOG . 'includes/version.php' ) );
        }

    /**
     * Function to check POST/GET/COOKIE/SESSION vars and validate if needed with defaults
     *
     * @param        $var_to_check
     * @param        $default_value
     * @param string $checkformat
     * @param string $if_invalid_value
     * @param null   $current_val
     *
     * @return int|null
     */
    function zipVarCheck( $var_to_check, $default_value, $checkformat = "", $if_invalid_value = "", $current_val = null ) {

        if ( $current_val != null && $default_value == $current_val ) {
            $y = $current_val;
        } else if ( $current_val != "" && $current_val != null ) {
            $y = $current_val;
        } else {
            if ( isset( $_GET[ $var_to_check ] ) ) {
                $y = $_GET[ $var_to_check ];
            } elseif ( isset( $_POST[ $var_to_check ] ) ) {
                $y = $_POST[ $var_to_check ];
            } elseif ( isset( $_COOKIE[ $var_to_check ] ) ) {
                $y = $_COOKIE[ $var_to_check ];
            } elseif ( isset( $_SESSION[ $var_to_check ] ) ) {
                $y = $_SESSION[ $var_to_check ];
            } else {
                $y = $default_value;
            }
        }
        $checkformat = (string) $checkformat;

        if ( strpos( "$checkformat", "FILTER_VALIDATE_INT" ) !== false ) {
            if ( filter_var( $y, FILTER_VALIDATE_INT ) === 0 || ! filter_var( $y, FILTER_VALIDATE_INT ) === false ) {
                //all okay with $y
            } else {
                $y = $if_invalid_value;
            }
        } else if ( strpos( "$checkformat", "FILTER_VALIDATE_PIN" ) !== false ) {
            $opt = [ "options" => [ "regexp" => "/^[0-9]{4,8}$/" ] ];
            if ( filter_var( $y, FILTER_VALIDATE_REGEXP, $opt ) === false ) {
                $y = $if_invalid_value;
            }
        } else if ( strpos( "$checkformat", "FILTER_VALIDATE_FLOAT" ) !== false ) {
            $y = (float) $y;
            if ( ! filter_var( $y, FILTER_VALIDATE_FLOAT ) ) {
                $y = $if_invalid_value;
            }
        } else if ( strpos( "$checkformat", "FILTER_VALIDATE_DATE" ) !== false ) {
            if ( ! validateDate( $y, 'm/d/Y' ) ) {
                $y = $if_invalid_value;
            }
            //double check date length as weird values like 08/14/-18343974928 return true
            if ( strlen( $y ) != '10' ) {
                $y = $if_invalid_value;
            }
        } else if ( strpos( "$checkformat", "FILTER_VALIDATE_EMAIL" ) !== false ) {
            if ( ! filter_var( $y, FILTER_VALIDATE_EMAIL ) ) {
                $y = $if_invalid_value;
            }
        } else if ( strpos( "$checkformat", "FILTER_VALIDATE_URL" ) !== false ) {
            if ( ! filter_var( $y, FILTER_VALIDATE_URL ) ) {
                $y = $if_invalid_value;
            }
        } else if ( strpos( "$checkformat", "FILTER_VALIDATE_ARRAY" ) !== false ) {
            if ( ! is_array( $y ) ) {
                if ( is_array( $if_invalid_value ) ) {
                    $y = $if_invalid_value;
                } else {
                    $y = [ $if_invalid_value ];
                }
            }
        }

        return $y;
    }

    /**
     * @param        $date
     * @param string $format
     *
     * @return bool
     */
    function validateDate( $date, $format = 'Y-m-d H:i:s' ) {

        $d = DateTime::createFromFormat( $format, $date, new DateTimeZone( CFG_TIME_ZONE ) );

        return $d && $d->format( $format ) == $date;
    }

    /** Create a nested array from a directory root
     *
     * @param       $path
     * @param array $ignorefolders
     * @param int   $type
     * @param false $convertadmin
     */
    function zipGetDirArray( $path, $ignorefolders = [], $type = 0, $convertadmin = false ) {

        global $installedfiles, $cleancorefiles, $version, $customadminpath;

        if (!file_exists( $path)){

            echo '<br/><br/><span class="alert alert-danger m-4">' . ZIPUR_LANG_SEARCH_NO_DIR . ' (' . $path . ')</span><br/><br/>';

        } else {
        $files = scandir($path);

        foreach ( $files as $file ) {
            if ( $file == '.' || $file == '..' ) {
                //do nothing
            } else if ( is_dir( $path . '/' . $file ) ) {
                if ( ( in_array( basename( $file ), $ignorefolders ) ) ) {
                    //do nothing for ignored folders
                } else {
                    zipGetDirArray( $path . '/' . $file, $ignorefolders, $type, $convertadmin );
                }
            } else {
                if ( ( in_array( basename( $file ), $ignorefolders ) ) ) {
                    //do nothing for ignored files
                } else {
                    if ( empty( $type ) ) {
                        $keypath = $path . '/' . $file;
                        $keypath = str_replace( DIR_FS_CATALOG, '', $keypath );

                        if ( $convertadmin ) {
                            $keypath = preg_replace( '/^\/' . $customadminpath . '/', '/admin', $keypath, 1 );
                        }

                        $installedfiles[ $keypath ] = hash_file( 'md5', $path . '/' . $file );
                    } else if ( $type == 1 ) {
                        $keypath = $path . '/' . $file;

                        $ospath                     = ( zipCheckIfPhoenix() ) ? 'CE-Phoenix-' : 'oscommerce-';
                        $ospath2                    = ( zipCheckIfPhoenix() ) ? '' : '/catalog';
                        $keypath                    = str_replace( DIR_FS_ADMIN . 'clean_core/' . $ospath . trim( $version ) . $ospath2, '', $keypath );
                        $keypath                    = preg_replace( '/^\/admin/', '/' . $customadminpath . '', $keypath, 1 );
                        $cleancorefiles[ $keypath ] = hash_file( 'md5', $path . '/' . $file );
                    } else if ( $type == 2 ) {

                        //ignore any non-php files for catching patch versions
                        if ( strpos( $file, '.php' ) !== false ) {
                            $keypath          = $path . '/' . $file;
                            $cleancorefiles[] = $keypath;
                        }

                    }
                }
            }
        }
    }
    }

    /** Allow detect if OSC ot CE Phoenix
     *
     * @return bool
     */
    function zipCheckIfPhoenix() {

        if ( PROJECT_VERSION == 'OSCOM CE Phoenix' || PROJECT_VERSION == 'CE Phoenix' ) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * Adds bootstrap to admin tools if in OSC and not Phoenix
     */
    function zipOscCss() {

        if ( ! zipCheckIfPhoenix() ) {
            ?>
            <link rel="stylesheet"
                  href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.5.0/css/bootstrap.min.css"
                  integrity="sha256-aAr2Zpq8MZ+YA/D6JtRD3xtrwpEz2IqOS+pWD/7XKIw=" crossorigin="anonymous"/>
            <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.13.1/css/all.min.css"
                  integrity="sha256-2XFplPlrFClt0bIdPgpz8H7ojnk10H69xRqd9+uTShA=" crossorigin="anonymous"/>

            <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"
                    integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo"
                    crossorigin="anonymous"></script>
            <script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.5.0/js/bootstrap.min.js"
                    integrity="sha256-OFRAJNoaD8L3Br5lglV7VyLRf0itmoBzWUoM+Sji4/8=" crossorigin="anonymous"></script>
            <style>
                #adminAppMenu {
                    font-size: 0.7rem;
                }

                .table-responsive {
                    padding: 0px 20px;
                }
            </style>
            <?php
        }
    }

    /**
     * Ass banner to top of zipur addons for easy support, docs, etc.
     */
    function zipAdBanner() {

        ?>
        <div style="text-align: right; padding: 0px 40px; margin-bottom: 10px;">
            This tool created by @zipurman (<a href="https://PhoenixAddons.com" target="_blank">PhoenixAddons.com</a>)
            <?php
                if ( ! zipCheckIfPhoenix() ) {
                    ?>
                    <div style="text-align: center; padding: 10px; background-color: #d04949; border: 1px solid #991e1e; color: #eee; width: 60%; margin: 10px auto; border-radius: 0.5rem;">
                        Upgrade to <a href="https://www.oscommerce.com/Products" target="_blank" style="color: #000;">CE
                            Phoenix</a> today to get the most out of your OSCommerce Experience.
                    </div>
                    <?php
                }
            ?>
        </div>
        <?php
    }

    $version            = zlt_phoenix_version();
    $cleancorefiles     = [];
    $zip_lang_search    = zipVarCheck( 'zip_lang_search', '' );
    $zip_file_edit      = zipVarCheck( 'zip_file_edit', '' );
    $zip_file_data      = zipVarCheck( 'zip_file_data', '' );
    $zipur_set_language = zipVarCheck( 'zipur_set_language', '' );
    $editfileok         = 0;
    if ( ! empty( $zipur_set_language ) ) {
        $_SESSION['zip_language'] = $zipur_set_language;
    }

    zipOscCss();
    zipAdBanner();

    /** @var string $language */

    if ( empty( $_SESSION['zip_language'] ) ) {
        $_SESSION['zip_language'] = $language;
    }

    $adminlangpath   = DIR_FS_ADMIN . 'includes/languages/' . $_SESSION['zip_language'];
    $cataloglangpath = DIR_FS_CATALOG . 'includes/languages/' . $_SESSION['zip_language'];

    //Load the library files into an array
    zipGetDirArray( $adminlangpath, [], 2 );
    zipGetDirArray( $cataloglangpath, [], 2 );

    $file_constants = [];
    $matches        = [];

    /** Get file constants by comparing constants in memory before and after page included
     *
     * @param $file
     */
    function zipGetFileConst( $file ) {

        global $file_constants;

        error_reporting(0);
        ini_set( 'display_errors', 0 );

        $before = get_defined_constants( true );
        include_once( $file );
        $after = get_defined_constants( true );
        if ( isset( $after['user'] ) ) {
            if ( isset( $before['user'] ) && is_array($after['user']) && is_array($before['user'])) {
                $file_constants[ $file ] = array_diff_assoc( $after['user'], $before['user'] );
            } else {
                $file_constants[ $file ] = $after['user'];
            }
        }
    }

    /** Search file array for a match to search term and return array of matched files
     *
     * @param        $sKey
     * @param        $id
     * @param        $array
     * @param string $parentkey
     */
    function zipSearchArrayKeyVal( $sKey, $id, $array, $parentkey = '' ) {
        global $matches;
        foreach ( $array as $key => $val ) {
            if ( ! is_array( $val ) ) {
                if ( strpos( strtolower( $val ), strtolower( trim( $id ) ) ) !== false ) {
                    $matches[] = [ 'file' => $parentkey, 'key' => $key, 'value' => $val, ];
                }
            } else {
                zipSearchArrayKeyVal( $sKey, $id, $val, $key );
            }
        }

    }
    function zipGetFileVersion( $filename ) {

        //get this tool version number from above content block. Dynamically created by Update Creator.
        $getcheckfile  = file_get_contents( $filename );
        $checkstartloc = strpos( $getcheckfile, 'Version' );
        $checkendloc   = strpos( $getcheckfile, "\n", $checkstartloc );
        $versiontext   = substr( $getcheckfile, $checkstartloc, $checkendloc - $checkstartloc + 2 );

        return preg_replace( '/[^0-9.]/', '', $versiontext );
    }

    foreach ( $cleancorefiles as $cleancorefile ) {
        zipGetFileConst( $cleancorefile );
    }
    if ( ! empty( $zip_file_edit ) ) {
        if ( ! empty( $file_constants[ $zip_file_edit ] ) ) {
            //only allow files in array to be edited just to be safe
            $editfileok = 1;
        }
    }
    if ( ! empty( $editfileok ) && ! empty( $zip_file_data ) ) {
        //save the file
        file_put_contents( $zip_file_edit, $zip_file_data );
        $editfileok = 0;
    }

?>
<style>
</style>
<script>
</script>
<?php
    $osprod               = ( zipCheckIfPhoenix() ) ? 'CE Phoenix' : 'OS Commerce';
    $zipFileVersion = zipGetFileVersion( basename( __FILE__ ) );

    function zipCEPBanner(){
        GLOBAL $version, $zipFileVersion, $osprod;
        ?>
        <div class="bg-dark text-light p-4 m-0 mw-100 rounded">
            <div class="row">
                <div class="col-sm">
                    <a href="https://phoenixaddons.com" target="_blank"><img src="https://phoenixaddons.com/wp-content/uploads/2020/08/CE-Phoenix_Addons_logo2.png" style="width: 220px;"></a>
                </div>
                <div class="col-sm text-center">
                    <h4 class="display-7 mb-2"><?php echo HEADING_TITLE . '<br/><small>(' . $zipFileVersion . ')</small>'; ?></h4>
                </div>
                <div class="col-sm text-center">
                    <strong class="display-8 mb-2"><?php echo '(' . $osprod . ' ' . TABLE_HEADING_VERSION . ' ' . $version . ')'; ?></strong>
                </div>
            </div>
        </div>
        <?php
    }
    zipCEPBanner();

?>
<br/>
<small><i><?php echo ZIPUR_LANG_SEARCH_NOTICE; ?></i></small>

<?php

    $languages_query_raw = "select * from languages order by sort_order, name";
    $languages_query     = zlt_db_query( $languages_query_raw );

    while ( $languages = zlt_fetch_array( $languages_query ) ) {
        $buttonclass = ( $_SESSION['zip_language'] == $languages['directory'] ) ? 'btn-outline-primary' : 'btn-outline-secondary';
        ?>
        <a class="btn <?php echo $buttonclass; ?>"
           href="zipur_language_tool.php?zipur_set_language=<?php echo $languages['directory']; ?>"><?php echo $languages['name']; ?></a>

        <?php
    }
?>
<hr/>
<?php
    if ( empty( $editfileok ) ) {
        if ( ! empty( $zip_lang_search ) ) {
            zipSearchArrayKeyVal( 'value', $zip_lang_search, $file_constants );
            echo '<h4>' . ZIPUR_LANG_SEARCH_RESULT_TEXT . ' <i class="text-danger">' . $zip_lang_search . '</i></h4>';
        }
        ?>
        <form action="zipur_language_tool.php" method="post">
            <table class="table table-dark table-hover">
                <tbody>
                <tr>
                    <td class="text-right">
                        <?php echo ZIPUR_LANG_SEARCH_TEXT; ?>
                    </td>
                    <td class="">
                        <input type="text" size="40" name="zip_lang_search"
                               value="<?php echo $zip_lang_search; ?>"><br/><br/>
                    </td>
                    <td class="">
                        <button class="btn btn-success"><?php echo ZIPUR_LANG_SEARCH_BUTTON_TEXT; ?></button>
                    </td>
                </tr>
                </tbody>
            </table>
        </form>
        <?php

        if ( ! empty( $matches ) ) {
            ?>
            <div class="table-responsive mb-4 mt-4">
                <?php
                    foreach ( $matches as $match ) {
                        $match['value'] = str_ireplace( $zip_lang_search, '<i class="text-danger bg-warning">' . $zip_lang_search . '</i>', $match['value'] );
                        $file           = str_replace( DIR_FS_CATALOG, '', $match['file'] );
                        ?>
                        <table class="table table-striped table-hover">
                            <tbody>
                            <tr>
                                <td class="text-light bg-dark text-right"><?php echo TABLE_HEADING_TABLE_FILE; ?>
                                    :
                                </td>
                                <td class=""><?php echo $file; ?> <a
                                            href="zipur_language_tool.php?zip_lang_search=<?php echo $zip_lang_search; ?>&zip_file_edit=<?php echo $match['file']; ?>"><i
                                                class="fas fa-edit"></i> Edit</a></td>
                            </tr>
                            <tr>
                                <td class="text-light bg-dark text-right"><?php echo TABLE_HEADING_COLUMN_CONST; ?>
                                    :
                                </td>
                                <td class=""><?php echo $match['key']; ?></td>
                            </tr>
                            <tr>
                                <td class="text-light bg-dark text-right"><?php echo TABLE_HEADING_COLUMN_VALUE; ?>
                                    :
                                </td>
                                <td class=""><?php echo $match['value']; ?></td>
                            </tr>
                            </tbody>
                        </table>
                        <?php
                    }
                ?>
            </div>
            <?php
        }
    } else {
        //edit file
        $file = str_replace( DIR_FS_CATALOG, '', $zip_file_edit );
        echo ZIPUR_LANG_SEARCH_EDIT_FILE_TEXT . ': ' . $file;
        $data = file_get_contents( $zip_file_edit );
        ?>
        <form action="zipur_language_tool.php" method="post">
            <table class="table table-dark table-hover">
                <tbody>
                <tr>
                    <td class="">
                        <textarea name="zip_file_data" rows="30" cols="110"><?php echo $data; ?></textarea>
                    </td>
                </tr>
                <tr>
                    <td class="">
                        <button class="btn btn-success"><?php echo ZIPUR_LANG_SAVE_BUTTON_TEXT; ?></button>
                        <a class="btn btn-secondary"
                           href="zipur_language_tool.php?zip_lang_search=<?php echo $zip_lang_search; ?>"><?php echo ZIPUR_LANG_CANCEL_BUTTON_TEXT; ?></a>
                    </td>
                </tr>
                </tbody>
            </table>
            <input type="hidden" name="zip_file_edit" value="<?php echo $zip_file_edit; ?>">
            <input type="hidden" name="zip_lang_search" value="<?php echo $zip_lang_search; ?>">
        </form>
        <?php
    }
    require 'includes/template_bottom.php';
    require 'includes/application_bottom.php';
?>
